/*				 - HEAP.C -

   Storage for "malloc".

   To change default heap size:

     1. Change MALLOC_BUFSIZE (or compile with -DMALLOC_BUFSIZE=xxxx)
     2. Compile this file with the options: -b -P -H_heap_of_memory
          also add suitable memory model or CPU options.
     3. Update library with xlib:

	  xlib
	  *def-cpu PROCESSOR_NAME
	  *rep-mod heap LIBRARY_FILE
	  *exit

    PROCESSOR_NAME and LIBRARY_FILE are the same as used during linking.

    If there is a need to have the heap-space in some dedicated area, the
    easiest way to accomplish that is to rename the data-segment (UDATA)
    to for example MYHEAP, and then insert that name in the xlink command
    file.  This renaming can be done like this:

	  xlib
	  *def-cpu PROCESSOR_NAME
	  *ren-seg heap UDATA MYHEAP
	  *exit

   8051 note: The UDATA segment is actually named X_UDATA
              assuming that HEAP.C is compiled with -DPTR_ATTRIBUTE=xdata -e

$Name: V3_34A $	   

*/

#include "memstruc.i"
/*
#ifdef MALLOC_BUFSIZE
#undef MALLOC_BUFSIZE 
#endif
#define MALLOC_BUFSIZE 0x7F000//0x7F000	//medio mega de memoria externa



#pragma memory=no_init


                               
static PTR_ATTRIBUTE char bulk_storage [0x7F000];  

char PTR_ATTRIBUTE *_last_heap_object;  
#pragma memory=default

char PTR_ATTRIBUTE *const _heap_of_memory = bulk_storage;

char PTR_ATTRIBUTE *const _top_of_heap = bulk_storage + 0x7F000 - 1;

  */
  
  
#ifndef MALLOC_BUFSIZE
#define MALLOC_BUFSIZE 0x7E000
#endif

/* Get number of align buckets from number of bytes */
#define __NR_ELEMENTS__ (__HEAP_SIZE__(MALLOC_BUFSIZE))

#pragma memory=no_init
/* Allocate the actual heap, */
static   __align_union__ bulk_storage[__NR_ELEMENTS__];        //MEM_ATTRIBUTE
/* a pointer to still free heap memory, */
char PTR_ATTRIBUTE *_last_heap_object;// = (char PTR_ATTRIBUTE *) bulk_storage; 

#pragma memory=default
/* a pointer to the first byte */
char PTR_ATTRIBUTE *const _heap_of_memory = (char PTR_ATTRIBUTE *) 
                                            bulk_storage;



/* and a pointer to last byte in the heap */
char PTR_ATTRIBUTE *const _top_of_heap = (char PTR_ATTRIBUTE *)
                                         (bulk_storage + __NR_ELEMENTS__ - 1);
/*----------------------------------------------------------------------------
** Inicializa el heap

void IniHeap (void)
{
  _last_heap_object = bulk_storage;
}
*/
